# Generated by Django 2.2.4 on 2019-08-06 18:22

from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='State',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, verbose_name='Name')),
                ('manual', models.BooleanField(default=False, verbose_name='Trigger manually')),
            ],
            options={
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='Workflow',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, unique=True, verbose_name='Name')),
                ('initial_state', models.ForeignKey(blank=True, null=True, on_delete=None, related_name='workflow_state', to='django_customflow.State', verbose_name='Initial state')),
            ],
        ),
        migrations.CreateModel(
            name='WorkflowModelRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('content_type', models.ForeignKey(on_delete=None, to='contenttypes.ContentType', unique=True, verbose_name='Content Type')),
                ('workflow', models.ForeignKey(on_delete=None, related_name='wmrs', to='django_customflow.Workflow', verbose_name='Workflow')),
            ],
        ),
        migrations.CreateModel(
            name='Transition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100, verbose_name='Name')),
                ('condition', models.CharField(blank=True, max_length=100, verbose_name='Condition')),
                ('task', models.CharField(blank=True, max_length=100, null=True, verbose_name='Task')),
                ('destination', models.ForeignKey(blank=True, null=True, on_delete=None, related_name='destination_state', to='django_customflow.State', verbose_name='Destination')),
                ('workflow', models.ForeignKey(on_delete=None, related_name='transitions', to='django_customflow.Workflow', verbose_name='Workflow')),
            ],
        ),
        migrations.AddField(
            model_name='state',
            name='transitions',
            field=models.ManyToManyField(blank=True, null=True, related_name='states', to='django_customflow.Transition', verbose_name='Transitions'),
        ),
        migrations.AddField(
            model_name='state',
            name='workflow',
            field=models.ForeignKey(on_delete=None, related_name='states', to='django_customflow.Workflow', verbose_name='Workflow'),
        ),
        migrations.CreateModel(
            name='LogObjectRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('content_id', models.PositiveIntegerField(blank=True, null=True, verbose_name='Content id')),
                ('create_time', models.DateTimeField(auto_now_add=True, help_text='log create time', verbose_name='create time')),
                ('source_state', models.CharField(blank=True, max_length=36, null=True, verbose_name='source state')),
                ('transition', models.CharField(blank=True, max_length=36, null=True, verbose_name='transition')),
                ('state', models.CharField(max_length=36, verbose_name='current state')),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=None, related_name='log_object', to='contenttypes.ContentType', verbose_name='Content type')),
            ],
        ),
        migrations.CreateModel(
            name='WorkflowObjectRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('content_id', models.PositiveIntegerField(blank=True, null=True, verbose_name='Content id')),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=None, related_name='workflow_object', to='contenttypes.ContentType', verbose_name='Content type')),
                ('workflow', models.ForeignKey(on_delete=None, related_name='wors', to='django_customflow.Workflow', verbose_name='Workflow')),
            ],
            options={
                'unique_together': {('content_type', 'content_id')},
            },
        ),
        migrations.CreateModel(
            name='StateObjectRelation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('content_id', models.PositiveIntegerField(blank=True, null=True, verbose_name='Content id')),
                ('content_type', models.ForeignKey(blank=True, null=True, on_delete=None, related_name='state_object', to='contenttypes.ContentType', verbose_name='Content type')),
                ('state', models.ForeignKey(on_delete=None, to='django_customflow.State', verbose_name='State')),
            ],
            options={
                'unique_together': {('content_type', 'content_id', 'state')},
            },
        ),
    ]
